#[derive(
    Debug,
    Clone,
    conjure_object::serde::Serialize,
    conjure_object::serde::Deserialize,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash
)]
#[serde(crate = "conjure_object::serde")]
#[conjure_object::private::staged_builder::staged_builder]
#[builder(crate = conjure_object::private::staged_builder, update, inline)]
pub struct SavedViewMetadata {
    #[serde(rename = "rid")]
    rid: super::super::super::rids::api::SavedViewRid,
    #[serde(rename = "resourceType")]
    resource_type: super::ResourceType,
    #[builder(into)]
    #[serde(rename = "title")]
    title: String,
    #[builder(
        default,
        custom(
            type = impl
            Into<Option<super::super::super::api::Symbol>>,
            convert = |v|v.into().map(Box::new)
        )
    )]
    #[serde(rename = "symbol", skip_serializing_if = "Option::is_none", default)]
    symbol: Option<Box<super::super::super::api::Symbol>>,
    #[builder(
        default,
        custom(
            type = impl
            Into<Option<super::super::super::api::Color>>,
            convert = |v|v.into().map(Box::new)
        )
    )]
    #[serde(rename = "color", skip_serializing_if = "Option::is_none", default)]
    color: Option<Box<super::super::super::api::Color>>,
    #[serde(rename = "isArchived")]
    is_archived: bool,
    #[serde(rename = "createdAt")]
    created_at: conjure_object::DateTime<conjure_object::Utc>,
    #[serde(rename = "createdBy")]
    created_by: super::super::super::rids::api::UserRid,
    #[serde(rename = "updatedAt")]
    updated_at: conjure_object::DateTime<conjure_object::Utc>,
}
impl SavedViewMetadata {
    #[inline]
    pub fn rid(&self) -> &super::super::super::rids::api::SavedViewRid {
        &self.rid
    }
    #[inline]
    pub fn resource_type(&self) -> &super::ResourceType {
        &self.resource_type
    }
    #[inline]
    pub fn title(&self) -> &str {
        &*self.title
    }
    #[inline]
    pub fn symbol(&self) -> Option<&super::super::super::api::Symbol> {
        self.symbol.as_ref().map(|o| &**o)
    }
    #[inline]
    pub fn color(&self) -> Option<&super::super::super::api::Color> {
        self.color.as_ref().map(|o| &**o)
    }
    #[inline]
    pub fn is_archived(&self) -> bool {
        self.is_archived
    }
    #[inline]
    pub fn created_at(&self) -> conjure_object::DateTime<conjure_object::Utc> {
        self.created_at
    }
    #[inline]
    pub fn created_by(&self) -> &super::super::super::rids::api::UserRid {
        &self.created_by
    }
    #[inline]
    pub fn updated_at(&self) -> conjure_object::DateTime<conjure_object::Utc> {
        self.updated_at
    }
}
